/*
 * game.cpp
 *
 *  Created on: 28/mar/2012
 *      Author: bertini
 */


#include "WeaponBehaviour.h"
#include "Character.h"
#include "Dungeon.h"

#include <iostream>

using namespace std;

int main() {

	Dungeon* dungeon;
	dungeon = new Dungeon;
	if( dungeon->createDungeon(80,25,12) )
		dungeon->showDungeon();

	Character* hero = 0;
	hero = new Character( 15, 18 );

	WeaponBehaviour* sword = 0;
	sword = new WeaponBehaviour;
	sword->setStrenght( 15 );
	hero->setWeapon( *sword );

	Character* monsters = 0;
	monsters = new Character[4];

	WeaponBehaviour* fang = 0;
	fang = new WeaponBehaviour;
	fang->setStrenght( 10 );

	const int maxMonsters = 4;
	for(int i = 0; i < maxMonsters; i++) {
		monsters[i].setHP(14);
		monsters[i].setWeapon( *fang );
	}

	int monsterIdx = 0;
	cout << "Numero mostro da attaccare (da 0 a " << (maxMonsters-1) << ")" << endl;
	do {
		cin >> monsterIdx;
	} while( ((monsterIdx>=maxMonsters) || (monsterIdx<0)) );
	const int maxAttacks = 3;
	for(int i = 0; i < maxAttacks; i++) {
		cout << "Attacco eroe... ";
		hero->fight( monsters[monsterIdx] );
		if( monsters[monsterIdx].getHP() <= 0 ) {
			cout << "Il mostro  morto !" << endl;
			break;
		}
		cout << "Attacco mostro... ";
		monsters[monsterIdx].fight( *hero );
		if( hero->getHP() <= 0 ) {
			cout << "L'eroe  morto !" << endl;
			break;
		}
	}

	delete hero;
	delete sword;
	delete[] monsters;
	delete fang;

	delete dungeon;
}

